# -*- coding: utf-8 -*-
# Copyright 2017 The Wazo Authors  (see the AUTHORS file)
# SPDX-License-Identifier: GPL-3.0+

from xivo_dao.resources.moh.persistor import MOHPersistor
from xivo_dao.resources.moh.search import moh_search

from xivo_dao.helpers.db_manager import daosession


@daosession
def search(session, **parameters):
    return MOHPersistor(session, moh_search).search(parameters)


@daosession
def get(session, moh_uuid):
    return MOHPersistor(session, moh_search).get_by({'uuid': moh_uuid})


@daosession
def get_by(session, **criteria):
    return MOHPersistor(session, moh_search).get_by(criteria)


@daosession
def find(session, moh_uuid):
    return MOHPersistor(session, moh_search).find_by({'uuid': moh_uuid})


@daosession
def find_by(session, **criteria):
    return MOHPersistor(session, moh_search).find_by(criteria)


@daosession
def find_all_by(session, **criteria):
    return MOHPersistor(session, moh_search).find_all_by(criteria)


@daosession
def create(session, moh):
    return MOHPersistor(session, moh_search).create(moh)


@daosession
def edit(session, moh):
    MOHPersistor(session, moh_search).edit(moh)


@daosession
def delete(session, moh):
    MOHPersistor(session, moh_search).delete(moh)
